| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::ConnectionFactory Class Reference
Utililty classes

The ConnectionFactory class is responsible for constructing Connection objects according to application-defined settings. More...

`#include <TelepathyQt/ConnectionFactory>`

Inherits Tp::FixedFeatureFactory.

List of all members.

## Public Member Functions

- virtual ~ConnectionFactory ()
- PendingReady * proxy (const QString &busName, const QString &objectPath, const ChannelFactoryConstPtr &chanFactory, const ContactFactoryConstPtr &contactFactory) const

## Static Public Member Functions

- static ConnectionFactoryPtr create (const QDBusConnection &bus, const Features &features=Features())

## Protected Member Functions

- ConnectionFactory (const QDBusConnection &bus, const Features &features)
- virtual ConnectionPtr construct (const QString &busName, const QString &objectPath, const ChannelFactoryConstPtr &chanFactory, const ContactFactoryConstPtr &contactFactory) const
- virtual QString finalBusNameFrom (const QString &uniqueOrWellKnown) const

## Detailed Description

The ConnectionFactory class is responsible for constructing Connection objects according to application-defined settings.

The class is used by Account and other classes which construct Connection proxy instances to enable sharing instances of application-defined Connection subclasses with certain features always ready.

## Constructor & Destructor Documentation

Tp::ConnectionFactory::~ConnectionFactory | ( |  | ) | `[virtual]`

Class destructor.

Tp::ConnectionFactory::ConnectionFactory | ( | const QDBusConnection & | bus,
|  | const Features & | features
| ) |  | `[protected]`

Construct a new ConnectionFactory object.

As in create(), it should be noted that unlike Connection::becomeReady(), FeatureCore isn't assumed. If no features are specified, no Connection::becomeReady() call is made at all and the proxy won't be Connection::isReady().

Parameters:

  bus | The QDBusConnection for proxies constructed using this factory to use.
  features | The features to make ready on constructed Connections.

## Member Function Documentation

ConnectionFactoryPtr Tp::ConnectionFactory::create | ( | const QDBusConnection & | bus,
|  | const Features & | features = `Features()`
| ) |  | `[static]`

Create a new ConnectionFactory object.

Optionally, the features to make ready on all constructed proxies can be specified. The default is to make no features ready. It should be noted that unlike Connection::becomeReady(), FeatureCore isn't assumed. If no features are specified, which is the default behavior, no Connection::becomeReady() call is made at all and the proxy won't be Connection::isReady().

Parameters:

  bus | The QDBusConnection for proxies constructed using this factory to use.
  features | The features to make ready on constructed Connections.

Returns:
  A ConnectionFactoryPtr object pointing to the newly created ConnectionFactory object.

PendingReady * Tp::ConnectionFactory::proxy | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | const ChannelFactoryConstPtr & | chanFactory,
|  | const ContactFactoryConstPtr & | contactFactory
| ) |  | const

Constructs a Connection proxy and begins making it ready.

If a valid proxy already exists in the factory cache for the given combination of busName and objectPath, it is returned instead. All newly created proxies are automatically cached until they're either DBusProxy::invalidated() or the last reference to them outside the factory has been dropped.

The proxy can be accessed immediately after this function returns using PendingReady::proxy(). The ready operation only finishes, however, when the features specified by features(), if any, are made ready as much as possible. If the service doesn't support a given feature, they won't obviously be ready even if the operation finished successfully, as is the case for Connection::becomeReady().

Parameters:

  busName | The bus/service name of the D-Bus connection object the proxy is constructed for.
  objectPath | The object path of the connection.
  chanFactory | The channel factory to use for the Connection.
  contactFactory | The channel factory to use for the Connection.

Returns:
  A PendingReady operation with the proxy in PendingReady::proxy().

ConnectionPtr Tp::ConnectionFactory::construct | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | const ChannelFactoryConstPtr & | chanFactory,
|  | const ContactFactoryConstPtr & | contactFactory
| ) |  | const`[protected, virtual]`

Can be used by subclasses to override the Connection subclass constructed by the factory.

This is automatically called by proxy() to construct proxy instances if no valid cached proxy is found.

The default implementation constructs Tp::Connection objects.

Parameters:

  busName | The bus/service name of the D-Bus Connection object the proxy is constructed for.
  objectPath | The object path of the connection.
  chanFactory | The channel factory to use for the Connection.
  contactFactory | The channel factory to use for the Connection.

Returns:
  A pointer to the constructed Connection object.

QString Tp::ConnectionFactory::finalBusNameFrom | ( | const QString & | uniqueOrWellKnown | ) | const`[protected, virtual]`

Transforms well-known names to the corresponding unique names, as is appropriate for Connection

Parameters:

  uniqueOrWellKnown | The name to transform.

Returns:
  The unique name corresponding to uniqueOrWellKnown (which may be it itself).

Implements Tp::DBusProxyFactory.